//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1  clrYellow
#property indicator_color2  clrOlive
#property indicator_color3  clrOlive
#property indicator_color4  clrOrange
#property indicator_color5  clrOrange
#property indicator_color6  clrRed
#property indicator_width6  2

//
//
//
//
//

enum enPrices
{
   pr_close,      // Close
   pr_open,       // Open
   pr_high,       // High
   pr_low,        // Low
   pr_median,     // Median
   pr_typical,    // Typical
   pr_weighted,   // Weighted
   pr_average,    // Average (high+low+open+close)/4
   pr_medianb,    // Average median body (open+close)/2
   pr_tbiased,    // Trend biased price
   pr_haclose,    // Heiken ashi close
   pr_haopen ,    // Heiken ashi open
   pr_hahigh,     // Heiken ashi high
   pr_halow,      // Heiken ashi low
   pr_hamedian,   // Heiken ashi median
   pr_hatypical,  // Heiken ashi typical
   pr_haweighted, // Heiken ashi weighted
   pr_haaverage,  // Heiken ashi average
   pr_hamedianb,  // Heiken ashi median body
   pr_hatbiased   // Heiken ashi trend biased price
};

extern ENUM_TIMEFRAMES TimeFrame   = PERIOD_CURRENT;
extern int             LRlength    = 55;
extern double          stdchannel1 =  1;
extern double          stdchannel2 =  2;
extern enPrices        Price       = pr_haclose; // Price to use 
extern bool            Interpolate = true;

//
//
//
//
//

double lrBuffer[];
double upBuffer1[];
double dnBuffer1[];
double upBuffer2[];
double dnBuffer2[];
double slBuffer[];
double prices[];
string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,lrBuffer);  SetIndexLabel(0,"mean");
   SetIndexBuffer(1,upBuffer1); SetIndexLabel(1,"1st Std up");
   SetIndexBuffer(2,dnBuffer1); SetIndexLabel(2,"1st Std down");
   SetIndexBuffer(3,upBuffer2); SetIndexLabel(3,"2nd Std up");
   SetIndexBuffer(4,dnBuffer2); SetIndexLabel(4,"2nd Std down");
   SetIndexBuffer(5,slBuffer);  
   SetIndexBuffer(6,prices);
   
      //
      //
      //
      //
      //

      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame==-99;
      TimeFrame         = MathMax(TimeFrame,_Period);  
   IndicatorShortName(timeFrameToString(TimeFrame)+" prd ("+LRlength+")");
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int limit,i,n,counted_bars=IndicatorCounted();
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { prices[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (TimeFrame == Period())
   {
      for(i=limit; i>=0; i--)
      {
         prices[i] = getPrice(Price,Open,Close,High,Low,i);
         
         double slope;
         double value   = iLRValue(slope,LRlength,i);
         double stddev = 0;

            for(int k=0; k<LRlength; k++)
            {
               double diff = prices[i+k]-(value-k*slope);
                  slBuffer[i+k] = value-k*slope;
                  stddev += diff*diff;
            }
            slBuffer[i+k] = EMPTY_VALUE;
            stddev = MathSqrt(stddev/(LRlength-1.0));
      
         //
         //
         //
         //
         //
      
         lrBuffer[i]  = value;
         upBuffer1[i] = lrBuffer[i]+(stdchannel1*stddev);
         dnBuffer1[i] = lrBuffer[i]-(stdchannel1*stddev);
         upBuffer2[i] = lrBuffer[i]+(stdchannel2*stddev);
         dnBuffer2[i] = lrBuffer[i]-(stdchannel2*stddev);
      }
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for (i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         lrBuffer[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,LRlength,stdchannel1,stdchannel2,Price,0,y);
         upBuffer1[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,LRlength,stdchannel1,stdchannel2,Price,1,y);
         dnBuffer1[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,LRlength,stdchannel1,stdchannel2,Price,2,y);
         upBuffer2[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,LRlength,stdchannel1,stdchannel2,Price,3,y);
         dnBuffer2[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,LRlength,stdchannel1,stdchannel2,Price,4,y);
         slBuffer[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,LRlength,stdchannel1,stdchannel2,Price,5,y);

         //
         //
         //
         //
         //
      
            if (!Interpolate || y==iBarShift(NULL,TimeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,TimeFrame,y);
            for(n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(k = 1; k < n; k++)
            {
               lrBuffer[i+k]  = lrBuffer[i]  + (lrBuffer[i+n] -lrBuffer[i] )*k/n;
               upBuffer1[i+k] = upBuffer1[i] + (upBuffer1[i+n]-upBuffer1[i])*k/n;
               dnBuffer1[i+k] = dnBuffer1[i] + (dnBuffer1[i+n]-dnBuffer1[i])*k/n;
               upBuffer2[i+k] = upBuffer2[i] + (upBuffer2[i+n]-upBuffer2[i])*k/n;
               dnBuffer2[i+k] = dnBuffer2[i] + (dnBuffer2[i+n]-dnBuffer2[i])*k/n;
               if (slBuffer[i+n] != EMPTY_VALUE) slBuffer[i+k]  = slBuffer[i]  + (slBuffer[i+n] -slBuffer[i]) *k/n;
            }               
   }
   return(0);
}

//---------------------------------------------------------------------------------|
//                                                                                 |
//---------------------------------------------------------------------------------|
//
//
//
//
//

int    lrperiod=0;
double lrsumX;
double lrsumXSqr;
double lrdivisor;

//
//
//
//
//

double iLRValue(double& LinearRegSlope, int len, int shift)
{
   double LinearRegValue;
   double Intercept;
   double SumXY = 0;
   double SumY  = 0;

   //
   //
   //
   //
   //

   if (lrperiod != len)
   {
      lrperiod  = len;
      lrsumX    = lrperiod * (lrperiod-1) / 2.0;
      lrsumXSqr = lrperiod * (lrperiod-1) * (2.0 * lrperiod - 1.0) / 6.0;
      lrdivisor = MathPow(lrsumX,2.0) - lrperiod * lrsumXSqr;
   }

   //
   //
   //
   //
   //

   for (int i=0; i<lrperiod; i++)
   {
      double price = prices[i+shift];
            SumXY += i*price;
            SumY  +=   price;
   }
   if( lrdivisor != 0 ) 
         	LinearRegSlope = (lrperiod * SumXY - lrsumX * SumY)/lrdivisor;
   else     LinearRegSlope = 0; 
   
   //
   //
   //
   //
   //
   
   Intercept      = (SumY - LinearRegSlope * lrsumX) / lrperiod ;
	LinearRegValue = Intercept  + LinearRegSlope * (lrperiod-1);
   return(LinearRegValue);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//
//

double workHa[][4];
double getPrice(int price, const double& open[], const double& close[], const double& high[], const double& low[], int i, int instanceNo=0)
{
  if (price>=pr_haclose && price<=pr_hatbiased)
   {
      if (ArrayRange(workHa,0)!= Bars) ArrayResize(workHa,Bars);
         int r = Bars-i-1;
         
         //
         //
         //
         //
         //
         
         double haOpen;
         if (r>0)
                haOpen  = (workHa[r-1][instanceNo+2] + workHa[r-1][instanceNo+3])/2.0;
         else   haOpen  = (open[i]+close[i])/2;
         double haClose = (open[i] + high[i] + low[i] + close[i]) / 4.0;
         double haHigh  = MathMax(high[i], MathMax(haOpen,haClose));
         double haLow   = MathMin(low[i] , MathMin(haOpen,haClose));

         if(haOpen  <haClose) { workHa[r][instanceNo+0] = haLow;  workHa[r][instanceNo+1] = haHigh; } 
         else                 { workHa[r][instanceNo+0] = haHigh; workHa[r][instanceNo+1] = haLow;  } 
                                workHa[r][instanceNo+2] = haOpen;
                                workHa[r][instanceNo+3] = haClose;
         //
         //
         //
         //
         //
         
         switch (price)
         {
            case pr_haclose:     return(haClose);
            case pr_haopen:      return(haOpen);
            case pr_hahigh:      return(haHigh);
            case pr_halow:       return(haLow);
            case pr_hamedian:    return((haHigh+haLow)/2.0);
            case pr_hamedianb:   return((haOpen+haClose)/2.0);
            case pr_hatypical:   return((haHigh+haLow+haClose)/3.0);
            case pr_haweighted:  return((haHigh+haLow+haClose+haClose)/4.0);
            case pr_haaverage:   return((haHigh+haLow+haClose+haOpen)/4.0);
            case pr_hatbiased:
               if (haClose>haOpen)
                     return((haHigh+haClose)/2.0);
               else  return((haLow+haClose)/2.0);        
         }
   }
   
   //
   //
   //
   //
   //
   
   switch (price)
   {
      case pr_close:     return(close[i]);
      case pr_open:      return(open[i]);
      case pr_high:      return(high[i]);
      case pr_low:       return(low[i]);
      case pr_median:    return((high[i]+low[i])/2.0);
      case pr_medianb:   return((open[i]+close[i])/2.0);
      case pr_typical:   return((high[i]+low[i]+close[i])/3.0);
      case pr_weighted:  return((high[i]+low[i]+close[i]+close[i])/4.0);
      case pr_average:   return((high[i]+low[i]+close[i]+open[i])/4.0);
      case pr_tbiased:   
               if (close[i]>open[i])
                     return((high[i]+close[i])/2.0);
               else  return((low[i]+close[i])/2.0);        
   }
   return(0);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}